# -*- coding: utf-8 -*-
"""training june8.ipynb

Automatically generated by Colaboratory.

Original file is located at
    https://colab.research.google.com/drive/1U4qhc2PobOtD2k5CMuHxrnkt9KAdgyVl

# Linked List

**Creation and adding nodes**
"""

#class to represent each node of the linked list
class Node:
    def __init__(self, data):
        self.data = data
        self.next = None

    def __repr__(self):
        return self.data
#class to represent linked list

class LinkedList:
    def __init__(self):
        self.head = None

    def __repr__(self):
        node = self.head
        nodes = []
        while node is not None:
            nodes.append(node.data)
            node = node.next
        nodes.append("None")
        return " -> ".join(nodes)

llist = LinkedList() #Empty Linked List 
print(llist)

first_node = Node("monday")
llist.head = first_node   # Linked List with head 
print(llist)
second_node = Node("Tuesday")
third_node = Node("Wednesday")
first_node.next = second_node
second_node.next = third_node   # Linked List with end
print(llist)

"""# Travesing Linked List"""

#class to represent each node of the linked list
class Node:
    def __init__(self, data):
        self.data = data
        self.next = None

    def __repr__(self):
        return self.data
#class to represent linked list
class LinkedList2:
  def __init__(self, nodes=None):
    self.head = None
    if nodes is not None:
        node = Node(data=nodes.pop(0))
        self.head = node
        for elem in nodes:
            node.next = Node(data=elem)
            node = node.next
            
  def __repr__(self):
        node = self.head
        nodes = []
        while node is not None:
            nodes.append(node.data)
            node = node.next
        nodes.append("None")
        return " -> ".join(nodes)

  #for traversal
  def printList(self): 
       node = self.head 
       while (node): 
         print (node.data) 
         node = node.next

llist2 = LinkedList2(["M", "N", "O", "P", "Q"])
llist2.printList()

"""**Given a Linked List consist of data , a next pointer and also a random pointer which points to randome node of the list. Write a code for cloning this list.**"""

'''Python program to clone a linked list with next and arbitrary pointers'''
'''Done in O(n) time with O(1) extra space'''

class Node: 
	'''Structure of linked list node'''

	def __init__(self, data): 
		self.data = data 
		self.next = None
		self.random = None

def clone(original_root): 
	'''Clone a doubly linked list with random pointer'''
	'''with O(1) extra space'''

	'''Insert additional node after every node of original list'''
	curr = original_root 
	while curr != None: 
		new = Node(curr.data) 
		new.next = curr.next
		curr.next = new 
		curr = curr.next.next

	'''Adjust the random pointers of the newly added nodes'''
	curr = original_root 
	while curr != None: 
		curr.next.random = curr.random.next
		curr = curr.next.next

	'''Detach original and duplicate list from each other'''
	curr = original_root 
	dup_root = original_root.next
	while curr.next != None: 
		tmp = curr.next
		curr.next = curr.next.next
		curr = tmp 

	return dup_root 

def print_dlist(root): 
	'''Function to print the doubly linked list'''

	curr = root 
	while curr != None: 
		print('Data =', curr.data, ', Random =', curr.random.data) 
		curr = curr.next

####### Driver code ####### 
'''Create a doubly linked list'''
original_list = Node(1) 
original_list.next = Node(2) 
original_list.next.next = Node(3) 
original_list.next.next.next = Node(4) 
original_list.next.next.next.next = Node(5) 

'''Set the random pointers'''

# 1's random points to 3 
original_list.random = original_list.next.next

# 2's random points to 1 
original_list.next.random = original_list 

# 3's random points to 5 
original_list.next.next.random = original_list.next.next.next.next

# 4's random points to 5 
original_list.next.next.next.random = original_list.next.next.next.next

# 5's random points to 2 
original_list.next.next.next.next.random = original_list.next

'''Print the original linked list'''
print('Original list:') 
print_dlist(original_list) 

'''Create a duplicate linked list'''
cloned_list = clone(original_list) 

'''Print the duplicate linked list'''
print('\nCloned list:') 
print_dlist(cloned_list)

"""**Find modular node from the end: Given a singly linked list, write a function to find the first from the end whose n%k =0, where n is the number of elements in the list and k is an integer constant.
If n = 19 and k = 3 then we should return 16th node.**
"""

# Python3 program to find modular node 
# in a linked list 
import math 

# Linked list node 
class Node: 
	def __init__(self, data): 
		self.data = data 
		self.next = None

# Function to create a new node 
# with given data 
def newNode(data): 
	new_node = Node(data) 
	new_node.data = data 
	new_node.next = None
	return new_node 

# Function to find modular node 
# in the linked list 
def modularNode(head, k): 
	
	# Corner cases 
	if (k <= 0 or head == None): 
		return None

	# Traverse the given list 
	i = 1
	modularNode = None
	temp = head 
	while (temp != None): 
		if (i % k == 0): 
			modularNode = temp 

		i = i + 1
		temp = temp.next
	return modularNode 

# Driver Code 
if __name__ == '__main__': 
	head = newNode(1) 
	head.next = newNode(2) 
	head.next.next = newNode(3) 
	head.next.next.next = newNode(4) 
	head.next.next.next.next = newNode(5) 
	k = 2
	answer = modularNode(head, k) 
	print("Modular node is", end = ' ') 
	if (answer != None): 
		print(answer.data, end = ' ') 
	else: 
		print("None")

"""**Reversing  a linked list in pairs If you have a linked list that holds 1 -> 2 --> 3->4->X then after reverse it should return 2->1->4->3->X**"""

# Python program to swap the elements of linked list pairwise 

# Node class 
class Node: 

	# Constructor to initialize the node object 
	def __init__(self, data): 
		self.data = data 
		self.next = None

class LinkedList: 

	# Function to initialize head 
	def __init__(self): 
		self.head = None

	# Function to pairwise swap elements of a linked list 
	def pairwiseSwap(self): 
		temp = self.head 
		
		# There are no nodes in ilnked list 
		if temp is None: 
			return
		
		# Traverse furthur only if there are at least two 
		# left 
		while(temp is not None and temp.next is not None): 

			# Swap data of node with its next node's data 
			temp.data, temp.next.data = temp.next.data, temp.data 
			
			# Move temo by 2 fro the next pair 
			temp = temp.next.next
		
	# Function to insert a new node at the beginning 
	def push(self, new_data): 
		new_node = Node(new_data) 
		new_node.next = self.head 
		self.head = new_node 

	# Utility function to prit the linked LinkedList 
	def printList(self): 
		temp = self.head 
		while(temp): 
			print(temp.data) 
			temp = temp.next


# Driver program 
llist = LinkedList() 
llist.push(5) 
llist.push(4) 
llist.push(3) 
llist.push(2) 
llist.push(1) 

print("Linked list before calling pairWiseSwap() ")
llist.printList() 

llist.pairwiseSwap() 

print("\nLinked list after calling pairWiseSwap()")
llist.printList()

"""**Suppose there are two singly linked lists both of which intersect at some point and become a
single linked list. The head or start pointers of both the lists are known, but the intersecting node is not known. Also, the number of nodes in each of the lists before they intersect is unknown and may be different in each list. list 1 may have n nodes before it reaches the intersection point, and list 2. might have m nodes before it reaches the intersection point where m and n mny be m = n, m < n or m > n.**
"""

# Python3 implementation of the approach 

# Link list node 
class Node: 
	def __init__(self): 
		self.data = 0
		self.next = None

# Function to get the intersection point 
# of the given linked lists 
def getIntersectionNode( head1, head2): 

	curr1 = head1 
	curr2 = head2 

	# While both the pointers are not equal 
	while (curr1 != curr2): 

		# If the first pointer is None then 
		# set it to point to the head of 
		# the second linked list 
		if (curr1 == None) : 
			curr1 = head2 
		
		# Else point it to the next node 
		else: 
			curr1 = curr1.next
		
		# If the second pointer is None then 
		# set it to point to the head of 
		# the first linked list 
		if (curr2 == None): 
			curr2 = head1 
		
		# Else point it to the next node 
		else: 
			curr2 = curr2.next
		
	# Return the intersection node 
	return curr1.data 

# Driver code 

# Create two linked lists 

# 1st Linked list is 3,6,9,15,30 
# 2nd Linked list is 10,15,30 
	
# 15 is the intersection point 

newNode = None
head1 = Node() 
head1.data = 10
head2 = Node() 
head2.data = 3
newNode = Node() 
newNode.data = 6
head2.next = newNode 
newNode = Node() 
newNode.data = 9
head2.next.next = newNode 
newNode = Node() 
newNode.data = 15
head1.next = newNode 
head2.next.next.next = newNode 
newNode = Node() 
newNode.data = 30
head1.next.next = newNode 
head1.next.next.next = None

# Print the intersection node 
print( getIntersectionNode(head1, head2))